########################## TCL Event Handlers ##########################
#
#  Created by   @  Sat Aug 14 22:45:07 2004   ()
#  with Post Builder version  3.2.0.
#
########################################################################

  set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]
  set cam_debug_dir  [MOM_ask_env_var UGII_CAM_DEBUG_DIR]


  if { ![info exists mom_sys_post_initialized] } {

     source ${cam_post_dir}ugpost_base.tcl

     proc MOM_before_each_add_var {} {}
     proc MOM_before_each_event {} {}

#     set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]
#     source ${cam_debug_dir}mom_review.tcl

     MOM_set_debug_mode OFF


   ####  Listing File variables
     set mom_sys_list_output                       "ON"
     set mom_sys_header_output                     "ON"
     set mom_sys_list_file_rows                    "80"
     set mom_sys_list_file_columns                 "120"
     set mom_sys_warning_output                    "ON"
     set mom_sys_group_output                      "OFF"
     set mom_sys_list_file_suffix                  "lpt"
     set mom_sys_output_file_suffix                "up"
     set mom_sys_commentary_output                 "ON"
     set mom_sys_commentary_list                   "x z feed speed"

     set mom_sys_control_out                       "("
     set mom_sys_control_in                        ")"

     set mom_sys_post_initialized 1
  }


########## SYSTEM VARIABLE DECLARATIONS ##############
  set mom_sys_rapid_code                        "10"
  set mom_sys_linear_code                       "10"
  set mom_sys_circle_code(CLW)                  "30"
  set mom_sys_circle_code(CCLW)                 "20"
  set mom_sys_lathe_thread_advance_type(0)      "33"
  set mom_sys_lathe_thread_advance_type(1)      "33"
  set mom_sys_lathe_thread_advance_type(2)      "33" ; # 34
  set mom_sys_lathe_thread_advance_type(3)      "33" ; # 35
  set mom_sys_delay_code(SECONDS)               "4"
  set mom_sys_delay_code(REVOLUTIONS)           "4"
  set mom_sys_cutcom_code(OFF)                  "40"
  set mom_sys_cutcom_code(LEFT)                 "41"
  set mom_sys_cutcom_code(RIGHT)                "42"
  set mom_sys_adjust_code                       "43"
  set mom_sys_adjust_code_minus                 "44"
  set mom_sys_adjust_cancel_code                "49"
  set mom_sys_unit_code(IN)                     "70"
  set mom_sys_unit_code(MM)                     "71"
  set mom_sys_cycle_drill_break_chip_code       "73"
  set mom_sys_cycle_off                         "80"
  set mom_sys_cycle_drill_code                  "81"
  set mom_sys_cycle_drill_deep_code             "83"
  set mom_sys_cycle_drill_dwell_code            "82"
  set mom_sys_cycle_tap_code                    "84"
  set mom_sys_cycle_bore_code                   "85"
  set mom_sys_output_code(ABSOLUTE)             "27"
  set mom_sys_output_code(INCREMENTAL)          "26"
  set mom_sys_reset_code                        "58"
  set mom_sys_feed_rate_mode_code(IPM)          "94"
  set mom_sys_feed_rate_mode_code(IPR)          "95"
  set mom_sys_feed_rate_mode_code(FRN)          "93"
  set mom_sys_spindle_mode_code(SFM)            "96"
  set mom_sys_spindle_mode_code(RPM)            "97"
  set mom_sys_return_code                       "28"
  set mom_sys_cycle_ret_code(AUTO)              "98"
  set mom_sys_cycle_ret_code(MANUAL)            "99"
  set mom_sys_feed_rate_mode_code(MMPM)         "94"
  set mom_sys_feed_rate_mode_code(MMPR)         "95"
  set mom_sys_program_stop_code                 "0"
  set mom_sys_optional_stop_code                "1"
  set mom_sys_end_of_program_code               "2"
  set mom_sys_spindle_direction_code(CLW)       "3"
  set mom_sys_spindle_direction_code(CCLW)      "4"
  set mom_sys_spindle_direction_code(OFF)       "5"
  set mom_sys_tool_change_code                  "6"
  set mom_sys_coolant_code(MIST)                "7"
  set mom_sys_coolant_code(ON)                  "8"
  set mom_sys_coolant_code(FLOOD)               "8"
  set mom_sys_coolant_code(OFF)                 "9"
  set mom_sys_head_code(INDEPENDENT)            "21"
  set mom_sys_head_code(DEPENDENT)              "22"
  set mom_sys_rewind_code                       "30"
  set mom_sys_sim_cycle_drill                   "0"
  set mom_sys_sim_cycle_drill_dwell             "0"
  set mom_sys_sim_cycle_drill_deep              "0"
  set mom_sys_sim_cycle_drill_break_chip        "0"
  set mom_sys_sim_cycle_tap                     "0"
  set mom_sys_sim_cycle_bore                    "0"
  set mom_sys_cir_vector                        "Vector - Arc Center to Start"
  set mom_sys_spindle_max_rpm_code              "92"
  set mom_sys_spindle_cancel_sfm_code           "93"
  set mom_sys_spindle_ranges                    "0"
  set mom_sys_delay_output_mode                 "SECONDS"
  set mom_sys_rewind_stop_code                  "%"
  set mom_sys_home_pos(0)                       "0"
  set mom_sys_home_pos(1)                       "0"
  set mom_sys_home_pos(2)                       "0"
  set mom_sys_zero                              "0"
  set mom_sys_opskip_block_leader               "/"
  set mom_sys_seqnum_start                      "1"
  set mom_sys_seqnum_incr                       "1"
  set mom_sys_seqnum_freq                       "1"
  set mom_sys_seqnum_max                        "999"
  set mom_sys_lathe_x_double                    "1"
  set mom_sys_lathe_i_double                    "1"
  set mom_sys_lathe_x_factor                    "1"
  set mom_sys_lathe_y_factor                    "1"
  set mom_sys_lathe_z_factor                    "0.5"
  set mom_sys_leader(N)                         "N"
  set mom_sys_leader(X)                         "X"
  set mom_sys_leader(Y)                         "Y"
  set mom_sys_leader(Z)                         "Z"
  set mom_sys_turret_index(INDEPENDENT)         "1"
  set mom_sys_turret_index(DEPENDENT)           "2"
  set mom_sys_delay_param(SECONDS,format)       "Dwell_SECONDS"
  set mom_sys_delay_param(REVOLUTIONS,format)   "Dwell_REVOLUTIONS"
  set mom_sys_contour_feed_mode(LINEAR)         "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR)           "MMPM"
  set mom_sys_cycle_feed_mode                   "MMPM"
  set mom_sys_feed_param(IPM,format)            "Feed_IPM"
  set mom_sys_feed_param(IPR,format)            "Feed_IPR"
  set mom_sys_feed_param(FRN,format)            "Feed_INV"
  set mom_sys_vnc_rapid_dogleg                  "1"
  set mom_sys_prev_mach_head                    ""
  set mom_sys_curr_mach_head                    ""
  set mom_sys_feed_param(MMPM,format)           "Feed_MMPM"
  set mom_sys_feed_param(MMPR,format)           "Feed_MMPR"

####### KINEMATIC VARIABLE DECLARATIONS ##############
  set mom_kin_read_ahead_next_motion         1 ; # TRUE
  set mom_kin_arc_output_mode                   "QUADRANT"
  set mom_kin_arc_valid_plane                   "ZX"
  set mom_kin_clamp_time                        "2.0"
  set mom_kin_dependent_head                    "NONE"
  set mom_kin_flush_time                        "2.0"
  set mom_kin_ind_to_dependent_head_x           "0"
  set mom_kin_ind_to_dependent_head_z           "0"
  set mom_kin_independent_head                  "NONE"
  set mom_kin_linearization_flag                "0"
  set mom_kin_linearization_tol                 "0.001"
  set mom_kin_machine_resolution                "0.001"
  set mom_kin_machine_type                      "lathe"
  set mom_kin_max_arc_radius                    "999.998"
  set mom_kin_max_fpm                           "240"
  set mom_kin_max_fpr                           "240"
  set mom_kin_max_frn                           "239.99"
  set mom_kin_min_arc_length                    "0.001"
  set mom_kin_min_arc_radius                    "0.001"
  set mom_kin_min_fpm                           "1.0"
  set mom_kin_min_fpr                           "0.001"
  set mom_kin_min_frn                           "0.001"
  set mom_kin_output_unit                       "MM"
  set mom_kin_pivot_gauge_offset                "0.0"
  set mom_kin_post_data_unit                    "MM"
  set mom_kin_rapid_feed_rate                   "800"
  set mom_kin_tool_change_time                  "12.0"
  set mom_kin_x_axis_limit                      "200"
  set mom_kin_y_axis_limit                      "1000"
  set mom_kin_z_axis_limit                      "190"



#=============================================================
proc MOM_start_of_program { } {
#=============================================================
  global mom_logname mom_date is_from
  global mom_coolant_status mom_cutcom_status
  global mom_clamp_status mom_cycle_status
  global mom_spindle_status mom_cutcom_plane pb_start_of_program_flag
  global mom_cutcom_adjust_register mom_tool_adjust_register
  global mom_tool_length_adjust_register mom_length_comp_register
  global mom_flush_register mom_wire_cutcom_adjust_register
  global mom_wire_cutcom_status

    set pb_start_of_program_flag 0
    set mom_coolant_status UNDEFINED
    set mom_cutcom_status  UNDEFINED
    set mom_clamp_status   UNDEFINED
    set mom_cycle_status   UNDEFINED
    set mom_spindle_status UNDEFINED
    set mom_cutcom_plane   UNDEFINED
    set mom_wire_cutcom_status  UNDEFINED

    catch {unset mom_cutcom_adjust_register}
    catch {unset mom_tool_adjust_register}
    catch {unset mom_tool_length_adjust_register}
    catch {unset mom_length_comp_register}
    catch {unset mom_flush_register}
    catch {unset mom_wire_cutcom_adjust_register}

    set is_from ""

    OPEN_files ; #open warning and listing files
    LIST_FILE_HEADER ; #list header in commentary listing



  global mom_sys_post_initialized
  if { $mom_sys_post_initialized > 1 } { return }


#************
uplevel #0 {


#=============================================================
proc MOM_set_csys {} {
#=============================================================
  if [llength [info commands PB_CMD_kin_set_csys] ] {
    PB_CMD_kin_set_csys
  }
}


#=============================================================
proc MOM_msys {} {
#=============================================================
}


#=============================================================
proc MOM_end_of_program { } {
#=============================================================
   PB_CMD_check_sum
   MOM_force Once G_cutcom XX ZZ L F
   MOM_do_template cutcom_off_2
   MOM_force Once G_cutcom XX ZZ L F
   MOM_do_template cutcom_off_1

 #  MOM_do_template coolant_off
   MOM_do_template spindle_off
#   MOM_set_line_leader Once "/"
#   MOM_do_template end_of_path
   MOM_do_template end_of_program
   MOM_set_seq_off
#   MOM_do_template rewind_stop_code
  if [llength [info commands PB_summary_coord_output_H22 ] ] { PB_summary_coord_output_H22 }

#**** The following procedure lists the tool list with time in commentary data
   LIST_FILE_TRAILER

#**** The following procedure closes the warning and listing files
   CLOSE_files
}


  incr mom_sys_post_initialized


} ;# uplevel
#***********


}


#=============================================================
proc PB_TURRET_HEAD_SET { } {
#=============================================================
  global mom_kin_independent_head mom_tool_head
  global turret_current mom_warning_info

    set turret_current INDEPENDENT
    set ind_head NONE
    set dep_head NONE

    if {$mom_tool_head != $mom_kin_independent_head} {
       set turret_current DEPENDENT
    }

    if {$mom_tool_head != "$ind_head" && \
         $mom_tool_head != "$dep_head"} {
       set mom_warning_info "mom_tool_head = $mom_tool_head IS INVALID, USING NONE"
       MOM_catch_warning
    }
}


#=============================================================
proc PB_LATHE_THREAD_SET { } {
#=============================================================
  global mom_lathe_thread_type mom_lathe_thread_advance_type
  global mom_lathe_thread_lead_i mom_lathe_thread_lead_k
  global mom_motion_distance
  global mom_lathe_thread_increment mom_lathe_thread_value
  global thread_type thread_increment feed_rate_mode

    switch $mom_lathe_thread_advance_type {
      1 {set thread_type CONSTANT ;}
      2 {set thread_type INCREASING ; }
      default {set thread_type DECREASING ; }
    }

  global thread_value
  set thread_value 0.256

  if {$thread_type == "INCREASING" || $thread_type == "DECREASING"} {
    CATCH_WARNING "  $thread_type -  H22  "
    #MOM_abort "\n\n\n  $thread_type -  H22  ..\n\n\n"
    if {$mom_lathe_thread_type != 1} {
      set LENGTH $mom_motion_distance
      set LEAD $mom_lathe_thread_value
      set INCR $mom_lathe_thread_increment
      set E [expr abs(pow(($LEAD + ($INCR * $LENGTH)) , 2) - pow($LEAD , 2)) / 2 * $LENGTH]
      set tmp $E
    }
  }

  if {$thread_type == "CONSTANT"} {
     set LENGTH $mom_motion_distance
     set LEAD $mom_lathe_thread_value
     set INCR $mom_lathe_thread_increment
     if { ![info exists mom_lathe_thread_lead_k] } { set mom_lathe_thread_lead_k $LEAD }
     set tmp $mom_lathe_thread_lead_k
  }

  if {$tmp<=0.5} {
  	set thread_value 0.256
   } elseif {$tmp<=2.0} {
  	set thread_value 1.024
   } elseif {$tmp<=4.0} {
  	set thread_value 2.048
   } elseif {$tmp<=8.0} {
  	set thread_value 4.096
  	}


}


#=============================================================
proc MOM_before_motion { } {
#=============================================================
  global mom_motion_event mom_motion_type

    FEEDRATE_SET

    switch $mom_motion_type {
      ENGAGE   {PB_engage_move}
      APPROACH {PB_approach_move}
      FIRSTCUT {PB_first_cut}
      RETRACT  {PB_retract_move}
      RETURN   {PB_return_move}
    }

    if [llength [info commands PB_CMD_kin_before_motion] ] { PB_CMD_kin_before_motion }
    if [llength [info commands PB_CMD_before_motion] ]     { PB_CMD_before_motion }
}


#=============================================================
proc MOM_machine_mode {} {
#=============================================================
  global pb_start_of_program_flag
  global mom_operation_name mom_sys_change_mach_operation_name

   set mom_sys_change_mach_operation_name $mom_operation_name

    #if {$pb_start_of_program_flag == 0} {PB_start_of_program ; set pb_start_of_program_flag 1}

    if [llength [info commands PB_machine_mode] ] {
       if [catch {PB_machine_mode} res] {
          global mom_warning_info
          set mom_warning_info "$res"
          MOM_catch_warning
       }
    }
}


#=============================================================
proc PB_FORCE { option args } {
#=============================================================
   set adds [join $args]
   if { [info exists option] && [llength $adds] } {
      lappend cmd MOM_force
      lappend cmd $option
      lappend cmd [join $adds]
      eval [join $cmd]
   }
}


#=============================================================
proc PB_SET_RAPID_MOD { mod_list blk_list ADDR NEW_MOD_LIST } {
#=============================================================
  upvar $ADDR addr
  upvar $NEW_MOD_LIST new_mod_list
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2


   set new_mod_list [list]

   foreach mod $mod_list {
      switch $mod {
         "rapid1" {
            set elem $addr($traverse_axis1)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         "rapid2" {
            set elem $addr($traverse_axis2)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         "rapid3" {
            set elem $addr($mom_cycle_spindle_axis)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         default {
            set elem $mod
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
      }
   }
}


########################
# Redefine FEEDRATE_SET
########################
if [llength [info commands ugpost_FEEDRATE_SET] ] {
   rename ugpost_FEEDRATE_SET ""
}

if [llength [info commands FEEDRATE_SET] ] {
   rename FEEDRATE_SET ugpost_FEEDRATE_SET
} else {
   proc ugpost_FEEDRATE_SET {} {}
}


#=============================================================
proc FEEDRATE_SET {} {
#=============================================================
   if [llength [info commands PB_CMD_kin_feedrate_set] ] {
      PB_CMD_kin_feedrate_set
   } else {
      ugpost_FEEDRATE_SET
   }
}


############## EVENT HANDLING SECTION ################


#=============================================================
proc PB_start_of_program { } {
#=============================================================

   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }

 global  mom_warning_info
 global  mom_output_file_basename
 global  mom_logname  mom_date  mom_machine_name

  set mom_warning_info "\n   H22-1MT1"
  MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;

  set mom_warning_info "\n :\n"
  append mom_warning_info "\tG01/G10/G11 -   (//) \n"
  append mom_warning_info "\tG02/G03 (G20/G30) (G21/G31) -   (//)\n"
  append mom_warning_info "\tG33 -  \n"
  append mom_warning_info "\tG26 -   \n"
  append mom_warning_info "\tG27 -    \n"
  append mom_warning_info "\tG4  - \n"
  append mom_warning_info "\tG40 -  \n"
  append mom_warning_info "\tG58 -   \"0\"\n"
  MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;

   #if [llength [info commands runWin ] ] { catch { runWin } ; }

   userModeSet

#   
global SUMX SUMY SUMZ
set SUMX 0
set SUMY 0
set SUMZ 0

   MOM_set_seq_off
   MOM_do_template rewind_stop_code
   MOM_set_seq_on
   MOM_force Once G_mode
   MOM_do_template absolute_mode

}


#=============================================================
proc MOM_start_of_path { } {
#=============================================================
  global mom_sys_in_operation
   set mom_sys_in_operation 1

  global pb_start_of_program_flag
  if {$pb_start_of_program_flag == 0} {PB_start_of_program ; set pb_start_of_program_flag 1}

  global first_linear_move ; set first_linear_move 0
   TOOL_SET MOM_start_of_path

   if [llength [info commands PB_CMD_kin_start_of_path] ] {
      PB_CMD_kin_start_of_path
   }
   MOM_force Once G_motion F X Z

}


#=============================================================
proc MOM_from_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev  mom_motion_type mom_kin_max_fpm
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
   catch { MOM_do_template from CREATE } errMes ; MOM_log_message "MOM_from_move->$errMes" ;
}


#=============================================================
proc MOM_first_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   PB_TURRET_HEAD_SET
   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc PB_auto_tool_change { } {
#=============================================================
#   PB_CMD_alignment_block
#   MOM_force Once G X Z
#   MOM_do_template tool_change_axis_preset
#   PB_CMD_start_of_alignment_character
   MOM_force Once T
#   MOM_do_template auto_tool_change
#   PB_CMD_end_of_alignment_character
}


#=============================================================
proc PB_manual_tool_change { } {
#=============================================================
#   PB_CMD_alignment_block
   MOM_do_template stop
#   PB_CMD_start_of_alignment_character
#   MOM_force Once T
#   MOM_do_template manual_tool_change
#   PB_CMD_end_of_alignment_character
}


#=============================================================
proc MOM_initial_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type

  global mom_kin_max_fpm mom_motion_event
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
      PB_CMD_output_spindle

 #  PB_CMD_spindle_sfm_prestart
  MOM_force Once G_motion XX L F
  MOM_do_template cutcom_on_1
  MOM_force Once ZZ L F
  MOM_do_template cutcom_on_2

  global mom_programmed_feed_rate
   if { [EQ_is_equal $mom_programmed_feed_rate 0] } {
      MOM_rapid_move
   } else {
      MOM_linear_move
   }
}


#=============================================================
proc MOM_first_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type
  global mom_kin_max_fpm mom_motion_event
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
   PB_CMD_spindle_sfm_prestart
   catch {MOM_$mom_motion_event}
}


#=============================================================
proc PB_approach_move { } {
#=============================================================
}


#=============================================================
proc PB_engage_move { } {
#=============================================================
}


#=============================================================
proc PB_first_cut { } {
#=============================================================
}


#=============================================================
proc PB_first_linear_move { } {
#=============================================================
   PB_CMD_output_spindle
}


#=============================================================
proc PB_retract_move { } {
#=============================================================
}


#=============================================================
proc PB_return_move { } {
#=============================================================
}


#=============================================================
proc MOM_gohome_move { } {
#=============================================================
   PB_CMD_gohome_move
}

#=============================================================
proc PB_CMD_check_sum { } {
#=============================================================
#
 global mom_warning_info
 global mom_operation_name
 global mom_sys_in_operation
 global mom_pos mom_prev_pos
 global mom_sys_lathe_x_factor  mom_sys_lathe_x_double  mom_sys_lathe_z_factor
 global SUMX SUMY SUMZ

 set vx 0.0
 set vz 0.0

 global mom_output_mode
 if {$mom_output_mode=="INCREMENTAL"} {
   set vx $mom_prev_pos(0)
   set vz $mom_prev_pos(2)
 }

 set vx [ expr  ( $mom_pos(0) - $vx ) * $mom_sys_lathe_x_factor * $mom_sys_lathe_x_double ]
 set vz [ expr  ( $mom_pos(2) - $vz ) * $mom_sys_lathe_z_factor ]

 set vx [ format "%.3lf" $vx ]
 set vz [ format "%.3lf" $vz ]

 set dx [ expr $SUMX + $vx*1000 ]
 set dz [ expr $SUMZ + $vz*1000 ]

 if {( (![EQ_is_zero $dx]) || (![EQ_is_zero $dz]) )} {

   	set dx [ expr (-1.0)*$dx/(1000. * $mom_sys_lathe_x_factor * $mom_sys_lathe_x_double) ]
   	set mom_pos(0) [ expr  $mom_pos(0) + $dx ]

   	set dz [ expr (-1.0)*$dz/(1000. * $mom_sys_lathe_z_factor ) ]
   	set mom_pos(2) [ expr  $mom_pos(2) + $dz ]

   	MOM_reload_variable -a  mom_pos

    MOM_output_to_listing_device " Warning:  $mom_operation_name \t  dx=$dx dz=$dz \n"

    if {$mom_sys_in_operation==0} {	MOM_rapid_move }

 }

}

#=============================================================
proc PB_CMD_gohome_move { } {
#=============================================================
   PB_CMD_check_sum
   MOM_rapid_move
}

#=============================================================
proc MOM_end_of_path { } {
#=============================================================

   if [llength [info commands PB_CMD_kin_end_of_path] ] {
      PB_CMD_kin_end_of_path
   }

   global mom_sys_in_operation
   set mom_sys_in_operation 0
}


#=============================================================
proc MOM_tool_change { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   PB_TURRET_HEAD_SET
   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc MOM_length_compensation { } {
#=============================================================
   TOOL_SET MOM_length_compensation
   MOM_do_template tool_length_adjust
}


#=============================================================
proc MOM_set_modes { } {
#=============================================================
   MODES_SET
}


#=============================================================
proc MOM_spindle_rpm { } {
#=============================================================
   SPINDLE_SET
}


#=============================================================
proc MOM_spindle_css { } {
#=============================================================
   SPINDLE_SET
}


#=============================================================
proc MOM_spindle_off { } {
#=============================================================
   MOM_do_template spindle_off
}


#=============================================================
proc MOM_coolant_on { } {
#=============================================================
   COOLANT_SET
   MOM_do_template coolant_on
}


#=============================================================
proc MOM_coolant_off { } {
#=============================================================
   COOLANT_SET
   MOM_do_template coolant_off
}


#=============================================================
proc PB_feedrates { } {
#=============================================================
}


#=============================================================
proc MOM_cutcom_on { } {
#=============================================================
   CUTCOM_SET
   MOM_do_template cutcom_on
}


#=============================================================
proc MOM_cutcom_off { } {
#=============================================================
   CUTCOM_SET
   MOM_do_template cutcom_off
}


#=============================================================
proc MOM_delay { } {
#=============================================================
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time

   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
    }

    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {
        set delay_time $mom_delay_revs
        global mom_warning_info mom_operation_name
        set mom_warning_info "\nWARNING: =$mom_operation_name \t      . !\n"
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       }
    }

   global feed
   set delay_time [ expr $delay_time/60.0 ] ; #   
   set delay_time [ expr $feed*5.0*$delay_time*200.0 ] ; #   X
   MOM_do_template delay
   MOM_force Once X
}


#=============================================================
proc MOM_opstop { } {
#=============================================================
   MOM_do_template opstop
}


#=============================================================
proc MOM_auxfun { } {
#=============================================================
   MOM_do_template auxfun
}


#=============================================================
proc MOM_prefun { } {
#=============================================================
   MOM_do_template prefun
}


#=============================================================
proc MOM_load_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   PB_TURRET_HEAD_SET
}


#=============================================================
proc MOM_stop { } {
#=============================================================
   MOM_do_template stop
}


#=============================================================
proc MOM_tool_preselect { } {
#=============================================================
  global mom_tool_preselect_number mom_tool_number mom_next_tool_number
   if {[info exists mom_tool_preselect_number]} {
      set mom_next_tool_number $mom_tool_preselect_number
   }
}


#=============================================================
proc MOM_linear_move { } {
#=============================================================
  global feed_mode mom_feed_rate mom_kin_rapid_feed_rate

   if { $feed_mode == "IPM" || $feed_mode == "MMPM" } {
      if { [EQ_is_ge $mom_feed_rate $mom_kin_rapid_feed_rate] } {
         MOM_rapid_move
         return
      }
   }

  global first_linear_move

   if { !$first_linear_move } {
      PB_first_linear_move
      incr first_linear_move
   }

   PB_CMD_output_spindle
   MOM_do_template linear_move
}


#=============================================================
proc MOM_circular_move { } {
#=============================================================
   global feed
   if {[ EQ_is_gt $feed 90.0 ]} { set feed 90.0 ; }

   PB_CMD_output_spindle
   MOM_do_template circular_move
}


#=============================================================
proc MOM_rapid_move { } {
#=============================================================
  global rapid_spindle_inhibit rapid_traverse_inhibit
  global spindle_first is_from
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2
  global mom_motion_event

   set aa(0) X ; set aa(1) Y ; set aa(2) Z
   RAPID_SET

 global feed
 global slowdn_time
 global mom_motion_distance mom_event_time

 set feed 700.0

 set V 8000.0 ; # /.
 set t1 [ expr $mom_event_time/60.0 ] ; # 

 set L [ expr ($V*$slowdn_time)/1000.0 ] ; # /2.0  ()
 if {$L>=$mom_motion_distance} {
 	set feed [ expr ($L/$slowdn_time)*60.0 ]
 }

 MOM_do_template rapid_move
}


#=============================================================
proc MOM_lathe_thread { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name LATHE_THREAD
}


#=============================================================
proc MOM_lathe_thread_move { } {
#=============================================================
  global cycle_init_flag

   PB_LATHE_THREAD_SET
   MOM_do_template thread_move
   set cycle_init_flag FALSE
}

set lathe_num_cut 0;
#=============================================================
proc MOM_thread_move { } {
#=============================================================
  global lathe_num_cut ; incr lathe_num_cut;
  if {$lathe_num_cut==3} { ; }
   PB_LATHE_THREAD_SET
   MOM_do_template thread_move
}

#=============================================================
proc MOM_start_of_thread { } { return ;}
#=============================================================

#=============================================================
proc MOM_thread { } {
#=============================================================
   MOM_linear_move
}

#=============================================================
proc MOM_end_of_thread  { } { return ; }
#=============================================================


#=============================================================
proc MOM_cycle_off { } {
#=============================================================
}


#=============================================================
proc MOM_cycle_plane_change { } {
#=============================================================
  global cycle_init_flag

   set cycle_init_flag TRUE
}


#=============================================================
proc MOM_cdrill { } {
#=============================================================
  global cycle_name  cycle_init_flag
  set cycle_init_flag TRUE  ;   set cycle_name CDRILL
}

#=============================================================
proc  MOM_cdrill_move { } {
#=============================================================
   MOM_linear_move
}

#=============================================================
proc MOM_cdrill_peck { } {
#=============================================================
  global cycle_name  cycle_init_flag
  set cycle_name CDRILL_PECK
}

#=============================================================
proc  MOM_cdrill_peck_move { } {
#=============================================================
 global mom_cycle_feed_to_pos
 MOM_linear_move
}

#=============================================================
proc MOM_cdrill_break_chip { } {
#=============================================================
  global cycle_name  cycle_init_flag
  set cycle_name CDRILL_BREAK_CHIP
}

#=============================================================
proc  MOM_cdrill_break_chip_move { } {
#=============================================================
 global mom_cycle_feed_to_pos
MOM_linear_move
}


#=============================================================
proc MOM_drill { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL
   CYCLE_SET
}


#=============================================================
proc MOM_drill_move { } {
#=============================================================
  global cycle_init_flag

   MOM_linear_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_drill_dwell_move { } {
#=============================================================
  global cycle_init_flag

   MOM_linear_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_deep { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DEEP
   CYCLE_SET
}


#=============================================================
proc MOM_drill_deep_move { } {
#=============================================================
  global cycle_init_flag

   MOM_linear_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_break_chip { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_BREAK_CHIP
   CYCLE_SET
}


#=============================================================
proc MOM_drill_break_chip_move { } {
#=============================================================
  global cycle_init_flag

   MOM_linear_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_tap { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name TAP
   CYCLE_SET
}


#=============================================================
proc MOM_tap_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_tap
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE
   CYCLE_SET
}


#=============================================================
proc MOM_bore_move { } {
#=============================================================
  global cycle_init_flag

   MOM_linear_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_sequence_number { } {
#=============================================================
   SEQNO_SET
}


#=============================================================
proc PB_CMD_alignment_block { } {
#=============================================================
  global spindle_is_out

   MOM_force once X Z M_spindle M_coolant F

   if {[info exists spindle_is_out]} {unset spindle_is_out}
}


#=============================================================
proc PB_CMD_end_of_alignment_character { } {
#=============================================================
#  Return sequnece number back to orignal
#  This command may be used with the command "PM_CMD_start_of_alignment_character"
}


#=============================================================
proc PB_CMD_kin_end_of_path { } {
#=============================================================
  # Record tool time for this operation.
   if [llength [info commands PB_CMD_set_oper_tool_time] ] {
      PB_CMD_set_oper_tool_time
   }
}


#=============================================================
proc PB_CMD_kin_feedrate_set { } {
#=============================================================
# This procedure supercedes the functionalites provided by the
# FEEDRATE_SET in ugpost_base.tcl.  Post Builder automatically
# generates proper call sequences to this procedure in the
# Event handlers.
#
# This procedure must be used in conjunction with ugpost_base.tcl.
#
  global   feed com_feed_rate
  global   mom_feed_rate_output_mode super_feed_mode feed_mode
  global   mom_cycle_feed_rate_mode mom_cycle_feed_rate
  global   mom_cycle_feed_rate_per_rev
  global   mom_motion_type
  global   mom_warning_info
  global   Feed_IPM Feed_IPR Feed_MMPM Feed_MMPR Feed_INV
  global   mom_sys_feed_param
  global   mom_sys_cycle_feed_mode
  global mom_path_name


  set super_feed_mode $mom_feed_rate_output_mode

  set f_pm [ASK_FEEDRATE_FPM] ; set f_pr [ASK_FEEDRATE_FPR]

  switch $mom_motion_type {

    CYCLE {
      if [info exists mom_sys_cycle_feed_mode] {
         if { $mom_sys_cycle_feed_mode != "Auto" } {
            set mom_cycle_feed_rate_mode $mom_sys_cycle_feed_mode
         }
      }
      if {[hiset mom_cycle_feed_rate_mode]} { set super_feed_mode $mom_cycle_feed_rate_mode }
      if {[hiset mom_cycle_feed_rate]} { set f_pm $mom_cycle_feed_rate }
      if {[hiset mom_cycle_feed_rate_per_rev]} { set f_pr $mom_cycle_feed_rate_per_rev }
    }

    FROM -
    RETRACT -
    RETURN -
    LIFT -
    TRAVERSAL -
    GOHOME -
    GOHOME_DEFAULT -
    RAPID {
      SUPER_FEED_MODE_SET RAPID
    }

    default {
      if {[EQ_is_zero $f_pm] && [EQ_is_zero $f_pr]} {
        SUPER_FEED_MODE_SET RAPID
      } else {
        SUPER_FEED_MODE_SET CONTOUR
      }
    }
  }


  set feed_mode $super_feed_mode


 # Adjust feedrate format per Post output unit again.
  global mom_kin_output_unit
  if { $mom_kin_output_unit == "IN" } {
     switch $feed_mode {
       MMPM {
         set feed_mode "IPM"
         CATCH_WARNING "Feedrate mode MMPM changed to IPM"
       }
       MMPR {
         set feed_mode "IPR"
         CATCH_WARNING "Feedrate mode MMPR changed to IPR"
       }
     }
    CATCH_WARNING " 22     - "
    MOM_abort "\n\n\t 22     - \n\n"
  } else {
     switch $feed_mode {
       IPM {
         set feed_mode "MMPM"
         CATCH_WARNING "Feedrate mode IPM changed to MMPM .  22      IPM"
       }
       IPR {
         set feed_mode "MMPR"
         CATCH_WARNING "Feedrate mode IPR changed to MMPR .  22      IPR"
       }
     }
  }


  switch $feed_mode {
    IPM     -
    MMPM    { set feed $f_pm }
    IPR     -
    MMPR    {
    	        CATCH_WARNING " 22   c   - MMPR. Operation $mom_path_name \nFeedrate mode MMPR changed to MMPM"
    	        set feed $f_pm
    	        set feed_mode "MMPM"
     }
    DPM     {
    	#returns feed rate in degrees per min
    	CATCH_WARNING " 22   c   - DPM. Operation $mom_path_name "
    	set feed [PB_CMD_FEEDRATE_DPM]
     }
    FRN     -
    INVERSE {
    	# returns feed rate number in inverse time
    	CATCH_WARNING " 22   c   - FRN , INVERSE . Operation $mom_path_name "
    	set feed [PB_CMD_FEEDRATE_NUMBER]
     }
    default { set mom_warning_info "INVALID FEED RATE MODE" ; MOM_catch_warning ; return }
  }


 # Post Builder provided format for the current mode:
  if [info exists mom_sys_feed_param(${feed_mode},format)] {
    MOM_set_address_format F $mom_sys_feed_param(${feed_mode},format)
  } else {
    switch $feed_mode {
      IPM     -
      MMPM    -
      IPR     -
      MMPR    -
      DPM     -
      FRN     { MOM_set_address_format F Feed_${feed_mode} }
      INVERSE { MOM_set_address_format F Feed_INV }
    }
  }

 # Commentary output
  set com_feed_rate $f_pm


 # Execute user's commnad, if any.
  if [llength [info commands "PB_CMD_FEEDRATE_SET"]] {
     PB_CMD_FEEDRATE_SET
  }
}


#=============================================================
proc PB_CMD_kin_set_csys { } {
#=============================================================
   if [llength [info commands PB_CMD_set_csys] ] {
      PB_CMD_set_csys
   }
}


#=============================================================
proc PB_CMD_kin_start_of_path { } {
#=============================================================
#
#  This procedure is executed at the start of every operation.
#  It will check to see if a new head (post) was loaded and
#  will then initialize any functionality specific to that post.
#
#  It will also restore the initial Start of Program or End
#  of program event procedures.
#
#  DO NOT CHANGE THIS FILE UNLESS YOU KNOW WHAT YOU ARE DOING.
#  DO NOT CALL THIS PROCEDURE FROM ANY OTHER CUSTOM COMMAND.
#

  global mom_sys_head_change_init_program

   if [info exists mom_sys_head_change_init_program] {

      PB_CMD_kin_start_of_program
      unset mom_sys_head_change_init_program


     #<06-17-03 gsl> Moved from MOM_head to
     # execute start of head callback in new post's context.
      global CURRENT_HEAD
      if { [info exists CURRENT_HEAD] &&  [llength [info commands PB_start_of_HEAD__$CURRENT_HEAD]] } {
         PB_start_of_HEAD__$CURRENT_HEAD
      }

     # Restore master start & end of program handlers
      if [llength [info commands "MOM_start_of_program_save"]] {
         rename MOM_start_of_program ""
         rename MOM_start_of_program_save MOM_start_of_program
      }
      if [llength [info commands "MOM_end_of_program_save"]] {
         rename MOM_end_of_program_save MOM_end_of_program
      }

     # Restore master head change event handler
      if [llength [info commands "MOM_head_save"]] {
         if [llength [info commands "MOM_head"]] {
            rename MOM_head ""
         }
         rename MOM_head_save MOM_head
      }
   }

  # Initialize tool time accumulator for this operation.
   if [llength [info commands PB_CMD_init_oper_tool_time] ] {
      PB_CMD_init_oper_tool_time
   }
}


#=============================================================
proc PB_CMD_kin_start_of_program { } {
#=============================================================
#
#  This procedure will execute the following custom commands for
#  initialization.  They will be executed once at the start of
#  program and again each time they are loaded as a linked post.
#  After execution they will be deleted so that they are not
#  present when a different post is loaded.  You may add a call
#  to a procedure that you want executed when a linked post is
#  loaded.
#
#  Note that when a linked post is called in, the Start of Program
#  event marker is not executed again, only this procedure.
#
#  DO NOT REMOVE ANY LINES FROM THIS PROCEDURE UNLESS YOU KNOW
#  WHAT YOU ARE DOING.  DO NOT CALL THIS PROCEDURE FROM ANY
#  OTHER CUSTOM COMMAND.
#

   set command_list [list]

   lappend command_list  PB_CMD_initialize_tool_list
   lappend command_list  PB_CMD_init_tool_list
   lappend command_list  PB_CMD_init_tape_break
   lappend command_list  PB_CMD_set_lathe_arc_plane


   foreach cmd $command_list {
      if [llength [info commands "$cmd"]] {
         $cmd
         rename $cmd ""
         proc $cmd { args } {}
      }
   }
}


#=============================================================
proc PB_CMD_output_spindle { } {
#=============================================================
  global mom_spindle_mode spindle_is_out

  if {![info exists spindle_is_out]} {

  if {$mom_spindle_mode == "RPM"} {
     MOM_force once M_spindle S
     MOM_do_template spindle_rpm
  } elseif {$mom_spindle_mode == "SFM" || $mom_spindle_mode == "SMM"} {
     MOM_force once M_spindle S
     MOM_do_template spindle_rpm
  }
  set spindle_is_out 1
  }
}


#=============================================================
proc PB_CMD_set_csys { } {
#=============================================================
#  This custom command is provided as the default to nullify
#  the same command in a linked post that may have been
#  imported from pb_cmd_coordinate_system_rotation.tcl.
}


#=============================================================
proc PB_CMD_set_lathe_arc_plane { } {
#=============================================================
# This custom command will switch the valid arc plane for lathes
# from XY to ZX when the users selects the ZX lathe work
# plane in the MCS dialog.  If this custom command is not used then
# all arcs will be output as linear moves when the user selects the
# ZX Plane.
#
# Post Builder v3.0.1 executes this custom command automatically
# for all lathe posts.

  global mom_lathe_spindle_axis
  global mom_kin_arc_valid_plane

   if { [info exists mom_lathe_spindle_axis] && $mom_lathe_spindle_axis == "MCSZ" } {
      set mom_kin_arc_valid_plane  "ZX"
      MOM_reload_kinematics
   }
}


#=============================================================
proc PB_CMD_spindle_sfm_prestart { } {
#=============================================================
  global mom_spindle_mode

  if {$mom_spindle_mode == "SFM" || $mom_spindle_mode == "SMM"} {
    MOM_force once M_spindle S
    MOM_do_template spindle_rpm_preset
  }
}


#=============================================================
proc PB_CMD_start_of_alignment_character { } {
#=============================================================
# This command can be used to output a special sequence number character.
# Replace the ":" with any character that you require.
# You must use the command "PB_CMD_end_of_alignment_character" to reset
# the sequence number back to the original setting.
}


#=============================================================
proc EQ_is_zero { s } {
#=============================================================
   global mom_system_tolerance

   if [info exists mom_system_tolerance] {
      if { [expr abs($s)] <= $mom_system_tolerance } { return 1 } else { return 0 }
   } else {
      return 0
   }
}


#=============================================================
proc CATCH_WARNING { msg } {
#=============================================================
  global mom_warning_info
  global mom_motion_event
  global mom_event_number

   set level [info level]
   set call_stack ""
   for {set i 1} {$i < $level} {incr i} {
      set call_stack "$call_stack\[ [lindex [info level $i] 0] \]"
   }
   set mom_warning_info "$msg ($mom_motion_event $mom_event_number)" ;# $call_stack"
   MOM_catch_warning
}

#=============================================================
proc PB_catch_warning { } {
#=============================================================
  global mom_warning_info
  global mom_motion_event
  global mom_event_number
  global mom_operation_name

  set str "$mom_warning_info $mom_motion_event $mom_event_number $mom_operation_name "

  MOM_output_to_listing_device $str
}


#=============================================================
proc WORKPLANE_SET {  } {
#=============================================================
   global mom_cycle_spindle_axis
   global mom_sys_spindle_axis
   global traverse_axis1 traverse_axis2

   if { ![info exists mom_sys_spindle_axis] } {
      set mom_sys_spindle_axis(0) 0.0
      set mom_sys_spindle_axis(1) 0.0
      set mom_sys_spindle_axis(2) 1.0
   }

   if { ![info exists mom_cycle_spindle_axis] } {
      set x $mom_sys_spindle_axis(0)
      set y $mom_sys_spindle_axis(1)
      set z $mom_sys_spindle_axis(2)

      if { [EQ_is_zero $y] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 0
      } elseif { [EQ_is_zero $x] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 1
      } else {
         set mom_cycle_spindle_axis 2
      }
   }

   if { $mom_cycle_spindle_axis == 2 } {
      set traverse_axis1 0 ; set traverse_axis2 1
   } elseif { $mom_cycle_spindle_axis == 0 } {
      set traverse_axis1 1 ; set traverse_axis2 2
   } elseif { $mom_cycle_spindle_axis == 1 } {
      set traverse_axis1 0 ; set traverse_axis2 2
   }
}


#=============================================================
proc EQ_is_equal { s t } {
#=============================================================
   global mom_system_tolerance

   if [info exists mom_system_tolerance] {
      if { [expr abs($s - $t)] <= $mom_system_tolerance } { return 1 } else { return 0 }
   } else {
      return 0
   }
}


proc  MOM_before_output { } {
#_______________________________________________________________________________
# This procedure is executed just before a line is about to be output
# to the file. It loads the line into a variable MOM_o_buffer and then calls
# this procedure. When it returns from this procedure, the variable MOM_o_buffer
# is read and written to the file.
#_______________________________________________________________________________
	LIST_FILE
#########The following procedure invokes the listing file with warnings.
  global mom_o_buffer
# append mom_o_buffer "\015"

  if [llength [info commands PB_before_output ] ]     { PB_before_output }

}


if [info exists mom_sys_start_of_program_flag] {
   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }
} else {
   set mom_sys_head_change_init_program 1
   set mom_sys_start_of_program_flag 1
}






#***************************
# Source in user's tcl file.
#***************************
 set user_tcl_file ${cam_post_dir}tpk125_user.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }



 set slowdn_time 3.2
 set tp_feed 1

 global MAXFEED ; #       (/)
 set MAXFEED(0) 180.0 ; #  X = 180.0
 set MAXFEED(1) 90.0 ; #  Y = 0.0
 set MAXFEED(2) 90.0  ; #  Z = 90.0

#=============================================================
proc PB_CMD_before_motion { } {
#=============================================================

 global MAXFEED ; #      

  global mom_motion_event mom_motion_type  mom_current_motion

  global mom_kin_machine_resolution
  global mom_kin_max_fpm  mom_kin_rapid_feed_rate
  global mom_feed_rapid_value
  global feed

  global mom_prev_pos mom_pos  mom_motion_distance mom_tool_axis
  global mom_pos_arc_center  mom_arc_angle

  global mom_nxt_event  mom_nxt_event_count  mom_nxt_motion_event
  global mom_nxt_feed_rate mom_nxt_feed_rate_mode mom_nxt_mcs_goto  mom_nxt_tool_axis
  global mom_nxt_pos_arc_center  mom_nxt_arc_direction  mom_nxt_arc_angle mom_nxt_arc_radius
  global mom_motion_distance

  global mom_warning_info
  global mom_event_number  mom_event_time

  global mom_seqnum


#============================================================================
  if {![llength [info commands VEC_line_tan ] ]} { return }
  if {![llength [info commands VEC_circular_tan ] ]} { return }
  if {![llength [info commands VEC_different ] ]} { return }
  if {![llength [info commands debug_output_text ] ]} { return }
  if {![llength [info commands VEC_angle_vec ] ]} { return }
  if {![llength [info commands VEC_overfall_feed ] ]} { return }
#============================================================================

  if {[ EQ_is_zero $feed ]} { set feed $mom_kin_rapid_feed_rate }

  set angle 0.0
  VEC3_init 0.0 0.0 0.0 vec1
  VEC3_init 0.0 0.0 0.0 vec2
  VEC3_init 0.0 0.0 0.0 vec1f
  VEC3_init 0.0 0.0 0.0 vec2f
  set strm " angle between  "

  if {[info exists mom_current_motion]} {
   #
   if {$mom_current_motion=="linear_move" || \
   	  $mom_current_motion=="initial_move" || \
	     $mom_current_motion=="rapid_move" || \
		   $mom_current_motion=="from_move" || \
			$mom_current_motion=="first_move"} {
     VEC_line_tan mom_prev_pos mom_pos vec1  1
    }

   if {$mom_current_motion=="circular_move"} {
      VEC_circular_tan   mom_prev_pos  mom_pos  mom_pos_arc_center  $mom_arc_angle  vec1  2
    }

    append strm "$mom_current_motion  &&  "
    VEC_different  $feed  vec1  vec1f

  }

 if {[info exists mom_nxt_motion_event]} {
   #if {[string compare $mom_nxt_motion_event "none" ]!=0} { ; }
   # $mom_nxt_motion_event=="gohome_move"
   if {$mom_nxt_motion_event=="linear_move" || \
   		$mom_nxt_motion_event=="initial_move" || \
   			$mom_nxt_motion_event=="rapid_move"} {
        VEC_line_tan mom_pos mom_nxt_mcs_goto vec2 1
    }

   if {$mom_nxt_motion_event=="circular_move"} {
        VEC_circular_tan mom_pos mom_nxt_mcs_goto mom_nxt_pos_arc_center $mom_nxt_arc_angle vec2 1
   }

     append strm "$mom_nxt_motion_event ="
     VEC_different $mom_nxt_feed_rate vec2 vec2f

     set angle [VEC_angle_vec vec1 vec2 ] ;
     append strm "[format "%8.4f" $angle ]"
     debug_output_text 0 $strm

  } ; # end [info exists mom_nxt_motion_event]


   set flag_optimal 0

   ; #3.1 -            
   ; #3.2 -       
   ; #   , (  Fanuc)
   ; #           Vt, ,
   ; #              .
   ; # feed_optimal (Vt) -   .

   global feed_optimal
   if {[VEC_overfall_feed  vec1f vec2f MAXFEED ]} {

        for { set i 0 } { $i<3 } { incr i } {
          set R($i) 0.0
          if {$vec1f($i)>$MAXFEED($i)} {
          	set R($i) [ expr $vec1f($i)/$MAXFEED($i) ]
          	set flag_optimal 1
          }
        } ; # end for
        ;#  
        set Rmax $R(0)
        for { set j 1 } { $j<3 } { incr j } {
        	if {$Rmax<=$R($j)} { set Rmax $R($j) }
        }

        if {![EQ_is_zero $Rmax ]} {
          	set feed_optimal [ expr $feed/$Rmax ]
          	set feed_optimal [ format "%5.1f" $feed_optimal ]
        }
        if {$flag_optimal==1} {
          set feed $feed_optimal
          set mom_event_time [ expr $mom_motion_distance/$feed ]
        }

   } ; # end VEC_overfall_feed


  ;#4.0        -  F>=maxF{}
  if {[ EQ_is_gt $feed 90.0 ]} {
    if {$angle<=63.30} {
       set feed 90.0
    }
  } ; # EQ_is_gt

}


#=============================================================
proc VEC_overfall_feed { vector1 vector2 vectorMax } {
#    
#=============================================================
 upvar $vector1 v1  ;  upvar $vector2 v2 ; upvar $vectorMax vMax ;

 set flf 0 ;#    
 for {set i 0 } {$i<3} { incr i } {
  set df [ expr abs( $v2($i) - $v1($i) ) ]
  #set df [ expr abs( abs($v2($i)) - abs($v1($i)) ) ]
  if {[EQ_is_gt $df $vMax($i) ]} { set flf 1 }
 }
 debug_output_text 0 "    flf==$flf"
 return $flf
}


#================================================================================
proc PB_before_output { }  {
#    
#================================================================================
 global MOM_o_buffer
 global mom_o_buffer

 if {$mom_o_buffer!=""} {

    global tp_feed

    set str $mom_o_buffer
    set var0 ""

    set fl_adr(X) 0
    set fl_adr(Z) 0
    set fl_adr(F) 0
    #     
    foreach i { X Z F } {
     set strv "($i)"
     if {0!=[regexp -nocase -- "$strv"  $str  var0 ]} { set fl_adr($i) 1 ; }
    } ; # foreach

    #    ;
    #    F ------
    set strv "(F)(\[0-9\])+"
    set st [regexp -nocase -- "$strv"  $str  var0 ]
    if {$st!=0} {
       set var10 ""; set var9  "";
       scan $var0 "%1s %f" var9 var10
       if  { $var10!= ""} {
         if  {$var10!=0.0} {
           ; # 1 range  0.2  240 - /
           ; # 2 range  0.01  24 - /
           ; #      X -  90 /,
           ; #    Z -  180 /.
           set value [ expr $var10/100.0 ]
           ; #   ,   F70000
           if {$value!=700.0} {
             if {$fl_adr(Z)} {
           	if {$value>180.0} { set value 180.0 ; }
             }
             if {$fl_adr(X)} {
           	if {$value>90.0} { set value 90.0 ; }
             }
             ; #   
             set rank $tp_feed
             if {0.01<=$value && $value<0.2} { set rank 2 }
             if {24.0<$value && $value<=240.0} { set rank 1 }
             #if {0.2<=$value && $value<=24.0} { set rank $tp_feed }
             ; #  
             if {$rank==1} {
             	set value [ expr $value*5.0 ]
             	set value [ expr int($value) ]
             	set value [ expr ($rank * 10000 + $value) ]
              }
             if {$rank==2} {
             	set value [ expr $value*100.0 ]
             	set value [ expr ($rank * 10000 + $value) ]
              }
             set f1 [format "%5d" $value ]
             set fl [regsub -nocase  -- "$strv"  $str  "F$f1"  var0 ]
             set str $var0
           }
         }
       }
    } ; #    F ----------

  set mom_o_buffer $str
  PB_summary_coord_H22 $str
  }

}


#===============================================================
proc runWin { } {
#===============================================================
# global run_win
# if {$run_win==0} { return }
# set run_win 0

  ; #    #UGII_TMP_DIR=${TMP}
  set path [MOM_ask_env_var TEMP]
  if {$path==""} { set path [MOM_ask_env_var TMP] }
  if {$path==""} { set path [MOM_ask_env_var UGII_TMP_DIR ] }
  if {$path==""} { return }

  #
  # This section will assign the name.  Do NOT change any of the following lines.
  #
  global mom_event_handler_file_name
  set tempfile [file tail $mom_event_handler_file_name]
  set mom_sys_mill_postname [file rootname $tempfile]
  ;#       
  set strDir [file dirname $mom_event_handler_file_name]

  set strFile [file join $strDir "tpk125ui.ui.tcl" ]
#
#if {[file exists $strFile ]==0} {
#   catch { set wf [ open $strFile w ] ; } errMes ;
#   set bd [ info body tpk125ui_ui ]
#   puts $wf "set root . "
#   puts $wf "set args \"\" "
#   puts $wf $bd
#   close $wf
# }
#if {[file exists $strFile ]} {
   ; # source $strFile
   set tmp [ MOM_ask_unique_filename ]
   set tmpf "${path}/tpk125tcl.log"
   # /Tcl/bin/wish83.exe
   set cam_auxiliary_dir [MOM_ask_env_var UGII_CAM_AUXILIARY_DIR]
   set my_wish  "${cam_auxiliary_dir}ugwish"
   exec $my_wish $strFile -- "$tmpf"

   global radioSize radioGmode radioF timeS

   set rf [ open "$tmpf" "r" ]
   gets $rf  line
   set radioSize [ expr int($line) ]
   gets $rf  line
   set radioGmode  [ expr int($line) ]
   gets $rf  line
   set radioF  [ expr int($line) ]
   gets $rf  line
   set timeS  [ expr double($line) ]
   close $rf
   MOM_remove_file $tmpf

   MOM_log_message "File=$strFile  $radioSize $radioGmode $radioF  $timeS"

#}

 return 0
}

#===================================================
proc userModeSet { } {
#===================================================
   global radioSize radioGmode radioF timeS

   set radioSize 1
   set radioGmode 2
   set radioF 1
   set timeS 3.2


global slowdn_time
global tp_feed

   global mom_sys_rapid_code mom_sys_linear_code mom_sys_circle_code
   switch $radioSize {
    1 {
   	   MOM_set_address_format X Coordinate5
   	   MOM_set_address_format Z Coordinate5
   	   MOM_set_address_format I Coordinate5
   	   MOM_set_address_format K Coordinate5
	   set mom_sys_rapid_code                        "1"
	   set mom_sys_linear_code                       "1"
	   set mom_sys_circle_code(CLW)                  "3"
	   set mom_sys_circle_code(CCLW)                 "2"
   	}
    3 {
   	   MOM_set_address_format X Coordinate4
   	   MOM_set_address_format Z Coordinate4
   	   MOM_set_address_format I Coordinate4
   	   MOM_set_address_format K Coordinate4
	   set mom_sys_rapid_code                        "11"
	   set mom_sys_linear_code                       "11"
	   set mom_sys_circle_code(CLW)                  "31"
	   set mom_sys_circle_code(CCLW)                 "21"
   	}
    default  {
    	set radioSize 2
    	}
   }

   switch $radioGmode {
    2 {
	global mom_output_mode
	;# "ABSOLUTE", "INCREMENTAL"
	set  mom_output_mode  INCREMENTAL
	MOM_set_modes
  	}
   }

   switch $radioF {
    2 {
        set tp_feed 2
   	}
    default  {
    	set tp_feed 1
    	}
   }

   if {$timeS == ""} { set timeS 0.8 }
   if {$timeS<=0.0} { set timeS 0.8 }
   if [catch {expr {2.0 * $timeS}}] { set timeS 0.8 }
   set slowdn_time $timeS

 return 0
}

#=============================================================
proc  PB_summary_coord_H22 { strf }  {
#     X,Y,Z -  (  )
#=============================================================
  global SUMX SUMY SUMZ

  set ds 0.0 ; #   
  foreach i { X Y Z } {

   #    i ------
   set var0 ""
   set strv "($i)(\[- - +\])*(\[0-9\])*(\[.\])*(\[0-9\])+|($i)(\[- - +\])*(\[0-9\])+"
   set st [regexp -nocase -- "$strv"  $strf  var0 ]
   set pSUM($i) 0.0
   if {$st!=0} {
     set var10 ""; set var9  "";
     scan $var0 "%1s %f " var9 var10
     if  { $var10!= ""} {
	     set pSUM($i) $var10
	     set ds [ expr ($ds + $pSUM($i)*$pSUM($i) ) ]
     }
   } ; #    i ----------

  } ; # foreach

 set SUMX [ expr $SUMX +  $pSUM(X) ]
 set SUMY [ expr $SUMY +  $pSUM(Y) ]
 set SUMZ [ expr $SUMZ +  $pSUM(Z) ]

 set ds [ expr sqrt($ds)/1000.0 ]

 return 0
}

#=============================================================
proc PB_summary_coord_output_H22 { } {
#     
#=============================================================
  global SUMX SUMY SUMZ
  global TIME

  set SUMX [ expr ($SUMX/1000.0) ] ; set SUMX [ format "%8.3f" $SUMX ]
  set SUMY [ expr ($SUMY/1000.0) ] ; set SUMY [ format "%8.3f" $SUMY ]
  set SUMZ [ expr ($SUMZ/1000.0) ] ; set SUMZ [ format "%8.3f" $SUMZ ]
  MOM_output_to_listing_device "  :\n\t SUMX=$SUMX mm\n\t SUMZ=$SUMZ mm\n"

}
